#line 1 "ext/ohcount_native/ragel_parsers/bat.rl"
// bat.rl written by Mitchell Foral. mitchell<att>caladbolg<dott>net

/************************* Required for every parser *************************/
#ifndef RAGEL_BAT_PARSER
#define RAGEL_BAT_PARSER

#include "ragel_parser_macros.h"

// the name of the language
const char *BAT_LANG = "bat";

// the languages entities
const char *bat_entities[] = {
  "space", "comment", "string", "any"
};

// constants associated with the entities
enum {
  BAT_SPACE = 0, BAT_COMMENT, BAT_STRING, BAT_ANY
};

/*****************************************************************************/


#line 27 "ext/ohcount_native/ragel_parsers/bat.h"
static const char _bat_actions[] = {
	0, 1, 0, 1, 1, 1, 2, 1, 
	4, 1, 5, 1, 6, 1, 7, 1, 
	11, 1, 12, 1, 13, 1, 14, 1, 
	15, 1, 16, 1, 17, 1, 18, 1, 
	19, 1, 20, 2, 2, 9, 2, 3, 
	10, 2, 8, 3, 2, 8, 5
};

static const char _bat_cond_offsets[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 1, 1, 1, 1
};

static const char _bat_cond_lengths[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	1, 0, 0, 0, 0
};

static const short _bat_cond_keys[] = {
	13, 13, 0
};

static const char _bat_cond_spaces[] = {
	0, 0
};

static const char _bat_key_offsets[] = {
	0, 0, 2, 4, 5, 10, 13, 15, 
	18, 30, 32, 34, 37
};

static const short _bat_trans_keys[] = {
	77, 109, 77, 109, 10, 32, 82, 114, 
	9, 13, 32, 9, 13, 69, 101, 10, 
	12, 13, 9, 10, 12, 32, 82, 114, 
	269, 525, -128, 8, 14, 127, 9, 32, 
	69, 101, 10, 12, 13, 10, 0
};

static const char _bat_single_lengths[] = {
	0, 2, 2, 1, 3, 1, 2, 1, 
	8, 2, 2, 1, 1
};

static const char _bat_range_lengths[] = {
	0, 0, 0, 0, 1, 1, 0, 1, 
	2, 0, 0, 1, 0
};

static const char _bat_index_offsets[] = {
	0, 0, 3, 6, 8, 13, 16, 19, 
	22, 33, 36, 39, 42
};

static const char _bat_trans_targs[] = {
	7, 7, 4, 11, 11, 8, 8, 0, 
	5, 6, 6, 5, 4, 5, 5, 4, 
	1, 1, 4, 4, 4, 7, 9, 8, 
	8, 9, 10, 10, 3, 12, 8, 8, 
	0, 9, 9, 8, 2, 2, 8, 8, 
	8, 11, 8, 8, 4, 8, 4, 4, 
	4, 8, 8, 8, 8, 0
};

static const char _bat_trans_actions[] = {
	9, 9, 33, 1, 1, 23, 35, 0, 
	7, 44, 44, 7, 25, 7, 7, 27, 
	9, 9, 31, 29, 29, 9, 3, 35, 
	35, 3, 41, 41, 5, 5, 38, 38, 
	0, 3, 3, 15, 0, 0, 21, 17, 
	17, 0, 35, 19, 33, 23, 27, 31, 
	29, 15, 21, 17, 19, 0
};

static const char _bat_to_state_actions[] = {
	0, 0, 0, 0, 11, 0, 0, 0, 
	11, 0, 0, 0, 0
};

static const char _bat_from_state_actions[] = {
	0, 0, 0, 0, 13, 0, 0, 0, 
	13, 0, 0, 0, 0
};

static const char _bat_eof_trans[] = {
	0, 45, 46, 0, 0, 47, 48, 49, 
	0, 50, 51, 52, 53
};

static const int bat_start = 4;
static const int bat_first_final = 4;
static const int bat_error = 0;

static const int bat_en_bat_line = 8;
static const int bat_en_bat_entity = 4;

#line 70 "ext/ohcount_native/ragel_parsers/bat.rl"


/************************* Required for every parser *************************/

/* Parses a string buffer with Batch code.
 *
 * @param *buffer The string to parse.
 * @param length The length of the string to parse.
 * @param count Integer flag specifying whether or not to count lines. If yes,
 *   uses the Ragel machine optimized for counting. Otherwise uses the Ragel
 *   machine optimized for returning entity positions.
 * @param *callback Callback function. If count is set, callback is called for
 *   every line of code, comment, or blank with 'lcode', 'lcomment', and
 *   'lblank' respectively. Otherwise callback is called for each entity found.
 */
void parse_bat(char *buffer, int length, int count,
  void (*callback) (const char *lang, const char *entity, int start, int end)
  ) {
  init

  
#line 147 "ext/ohcount_native/ragel_parsers/bat.h"
	{
	cs = bat_start;
	ts = 0;
	te = 0;
	act = 0;
	}
#line 91 "ext/ohcount_native/ragel_parsers/bat.rl"
  cs = (count) ? bat_en_bat_line : bat_en_bat_entity;
  
#line 157 "ext/ohcount_native/ragel_parsers/bat.h"
	{
	int _klen;
	unsigned int _trans;
	short _widec;
	const char *_acts;
	unsigned int _nacts;
	const short *_keys;

	if ( p == pe )
		goto _test_eof;
	if ( cs == 0 )
		goto _out;
_resume:
	_acts = _bat_actions + _bat_from_state_actions[cs];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 ) {
		switch ( *_acts++ ) {
	case 7:
#line 1 "ext/ohcount_native/ragel_parsers/bat.rl"
	{ts = p;}
	break;
#line 179 "ext/ohcount_native/ragel_parsers/bat.h"
		}
	}

	_widec = (*p);
	_klen = _bat_cond_lengths[cs];
	_keys = _bat_cond_keys + (_bat_cond_offsets[cs]*2);
	if ( _klen > 0 ) {
		const short *_lower = _keys;
		const short *_mid;
		const short *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( _widec < _mid[0] )
				_upper = _mid - 2;
			else if ( _widec > _mid[1] )
				_lower = _mid + 2;
			else {
				switch ( _bat_cond_spaces[_bat_cond_offsets[cs] + ((_mid - _keys)>>1)] ) {
	case 0: {
		_widec = (short)(128 + ((*p) - -128));
		if ( 
#line 9 "ext/ohcount_native/ragel_parsers/bat.rl"
 p+1 < pe && *(p+1) != '\n'  ) _widec += 256;
		break;
	}
				}
				break;
			}
		}
	}

	_keys = _bat_trans_keys + _bat_key_offsets[cs];
	_trans = _bat_index_offsets[cs];

	_klen = _bat_single_lengths[cs];
	if ( _klen > 0 ) {
		const short *_lower = _keys;
		const short *_mid;
		const short *_upper = _keys + _klen - 1;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( _widec < *_mid )
				_upper = _mid - 1;
			else if ( _widec > *_mid )
				_lower = _mid + 1;
			else {
				_trans += (_mid - _keys);
				goto _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _bat_range_lengths[cs];
	if ( _klen > 0 ) {
		const short *_lower = _keys;
		const short *_mid;
		const short *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( _widec < _mid[0] )
				_upper = _mid - 2;
			else if ( _widec > _mid[1] )
				_lower = _mid + 2;
			else {
				_trans += ((_mid - _keys)>>1);
				goto _match;
			}
		}
		_trans += _klen;
	}

_match:
_eof_trans:
	cs = _bat_trans_targs[_trans];

	if ( _bat_trans_actions[_trans] == 0 )
		goto _again;

	_acts = _bat_actions + _bat_trans_actions[_trans];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 )
	{
		switch ( *_acts++ )
		{
	case 0:
#line 58 "ext/ohcount_native/ragel_parsers/bat.rl"
	{
  if (!line_contains_code) {
    whole_line_comment = 1;
    if (!line_start) line_start = ts;
  }
}
	break;
	case 1:
#line 50 "ext/ohcount_native/ragel_parsers/bat.rl"
	{ entity = BAT_SPACE; }
	break;
	case 2:
#line 52 "ext/ohcount_native/ragel_parsers/bat.rl"
	{ entity = NEWLINE;   }
	break;
	case 3:
#line 53 "ext/ohcount_native/ragel_parsers/bat.rl"
	{ entity = BAT_ANY;   }
	break;
	case 4:
#line 65 "ext/ohcount_native/ragel_parsers/bat.rl"
	{ entity = BAT_SPACE;   }
	break;
	case 5:
#line 66 "ext/ohcount_native/ragel_parsers/bat.rl"
	{ entity = BAT_COMMENT; }
	break;
	case 8:
#line 1 "ext/ohcount_native/ragel_parsers/bat.rl"
	{te = p+1;}
	break;
	case 9:
#line 31 "ext/ohcount_native/ragel_parsers/bat.rl"
	{te = p+1;{
    switch(entity) {
    case BAT_SPACE:
      ls
      break;
    case BAT_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(BAT_LANG)
      break;
    case NEWLINE:
      std_newline(BAT_LANG)
    }
  }}
	break;
	case 10:
#line 31 "ext/ohcount_native/ragel_parsers/bat.rl"
	{te = p+1;{
    switch(entity) {
    case BAT_SPACE:
      ls
      break;
    case BAT_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(BAT_LANG)
      break;
    case NEWLINE:
      std_newline(BAT_LANG)
    }
  }}
	break;
	case 11:
#line 31 "ext/ohcount_native/ragel_parsers/bat.rl"
	{te = p;p--;{
    switch(entity) {
    case BAT_SPACE:
      ls
      break;
    case BAT_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(BAT_LANG)
      break;
    case NEWLINE:
      std_newline(BAT_LANG)
    }
  }}
	break;
	case 12:
#line 51 "ext/ohcount_native/ragel_parsers/bat.rl"
	{te = p;p--;}
	break;
	case 13:
#line 31 "ext/ohcount_native/ragel_parsers/bat.rl"
	{te = p;p--;{
    switch(entity) {
    case BAT_SPACE:
      ls
      break;
    case BAT_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(BAT_LANG)
      break;
    case NEWLINE:
      std_newline(BAT_LANG)
    }
  }}
	break;
	case 14:
#line 31 "ext/ohcount_native/ragel_parsers/bat.rl"
	{te = p;p--;{
    switch(entity) {
    case BAT_SPACE:
      ls
      break;
    case BAT_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(BAT_LANG)
      break;
    case NEWLINE:
      std_newline(BAT_LANG)
    }
  }}
	break;
	case 15:
#line 31 "ext/ohcount_native/ragel_parsers/bat.rl"
	{{p = ((te))-1;}{
    switch(entity) {
    case BAT_SPACE:
      ls
      break;
    case BAT_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(BAT_LANG)
      break;
    case NEWLINE:
      std_newline(BAT_LANG)
    }
  }}
	break;
	case 16:
#line 68 "ext/ohcount_native/ragel_parsers/bat.rl"
	{te = p+1;}
	break;
	case 17:
#line 58 "ext/ohcount_native/ragel_parsers/bat.rl"
	{te = p;p--;{
    callback(BAT_LANG, bat_entities[entity], cint(ts), cint(te));
  }}
	break;
	case 18:
#line 58 "ext/ohcount_native/ragel_parsers/bat.rl"
	{te = p;p--;{
    callback(BAT_LANG, bat_entities[entity], cint(ts), cint(te));
  }}
	break;
	case 19:
#line 68 "ext/ohcount_native/ragel_parsers/bat.rl"
	{te = p;p--;}
	break;
	case 20:
#line 68 "ext/ohcount_native/ragel_parsers/bat.rl"
	{{p = ((te))-1;}}
	break;
#line 444 "ext/ohcount_native/ragel_parsers/bat.h"
		}
	}

_again:
	_acts = _bat_actions + _bat_to_state_actions[cs];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 ) {
		switch ( *_acts++ ) {
	case 6:
#line 1 "ext/ohcount_native/ragel_parsers/bat.rl"
	{ts = 0;}
	break;
#line 457 "ext/ohcount_native/ragel_parsers/bat.h"
		}
	}

	if ( cs == 0 )
		goto _out;
	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	if ( p == eof )
	{
	if ( _bat_eof_trans[cs] > 0 ) {
		_trans = _bat_eof_trans[cs] - 1;
		goto _eof_trans;
	}
	}

	_out: {}
	}
#line 93 "ext/ohcount_native/ragel_parsers/bat.rl"

  // if no newline at EOF; callback contents of last line
  if (count) { process_last_line(BAT_LANG) }
}

#endif

/*****************************************************************************/
